package zero1hd.rhythmbullet.screens;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.InputMultiplexer;
import com.badlogic.gdx.Preferences;
import com.badlogic.gdx.ScreenAdapter;
import com.badlogic.gdx.graphics.GL20;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.SpriteBatch;

import zero1hd.rhythmbullet.RhythmBullet;
import zero1hd.rhythmbullet.stages.CreativeHUD;
import zero1hd.rhythmbullet.stages.GameHUD;
import zero1hd.rhythmbullet.stages.GamePlayArea;

public class CreativeScreen extends ScreenAdapter {
	CreativeHUD chud;
	GameHUD ghud;
	GamePlayArea gamePlayArea;
	InputMultiplexer inputs;
	
	Preferences prefs;
	
	public CreativeScreen(RhythmBullet core, MainMenu mainMenu) {
		gamePlayArea = new GamePlayArea(core.getAssetManager(), core.getPrefs());
		ghud = new GameHUD(core.getDefaultSkin(), 100f, gamePlayArea, mainMenu, core);
		chud = new CreativeHUD(core, mainMenu, gamePlayArea, ghud);
		inputs = new InputMultiplexer(chud, ghud, gamePlayArea);

		this.prefs = core.getPrefs();
	}
	
	@Override
	public void show() {
		Gdx.input.setInputProcessor(inputs);
		gamePlayArea.loadShaders(prefs);
		super.show();
	}
	
	@Override
	public void render(float delta) {
		Gdx.gl.glClearColor(0.2f, 0.2f, 0.2f, 1f);
        Gdx.gl.glClear(GL20.GL_COLOR_BUFFER_BIT);

		gamePlayArea.getViewport().apply();
		gamePlayArea.act();
		gamePlayArea.draw();
		
		ghud.getViewport().apply();
		ghud.act();
		ghud.draw();
		
		chud.getViewport().apply();
		chud.act();
		chud.draw();
		super.render(delta);
	}
	
	@Override
	public void resize(int width, int height) {
		super.resize(width, height);
	}
	
	@Override
	public void dispose() {
		dispose();
		super.dispose();
	}
}
